package org.eclipse.palamedes.gdl.core.knowledgebase;

import java.util.TreeSet;

import org.eclipse.palamedes.gdl.core.ast.GDLForm;
import org.eclipse.palamedes.kif.core.knowledgebase.KnowledgeBase;

public class GDLKnowledgeBase extends KnowledgeBase {

    /**
     * The static member gdlKeywords contains the GDL keywords in a case
     * insensitive order.
     *
     * One can make a contains test against with a string to identify keywords.
     */
    public static final TreeSet<String> gdlKeywords =
                            new TreeSet<String>(String.CASE_INSENSITIVE_ORDER);

    /**
     * The static member gdlOperator contains the GDL operator in a case
     * insensitive order.
     *
     * One can make a contains test against with a string to identify operator.
     */
    public static final TreeSet<String> gdlOperators =
                            new TreeSet<String>(String.CASE_INSENSITIVE_ORDER);

    /**
     * Initializes gdlKeywords and gdlOperators.
     */
    static {
        gdlKeywords.add("init");
        gdlKeywords.add("true");
        gdlKeywords.add("role");
        gdlKeywords.add("next");
        gdlKeywords.add("does");
        gdlKeywords.add("legal");
        gdlKeywords.add("terminal");
        gdlKeywords.add("goal");

        gdlOperators.add("<=");
        gdlOperators.add("and");
        gdlOperators.add("or");
        gdlOperators.add("not");
        gdlOperators.add("distinct");
    }

    public GDLForm getGameAST() {
        return (GDLForm) description;
    }



}
