package org.eclipse.palamedes.gdl.core.model;

import org.eclipse.palamedes.kif.core.ast.KIFTerm;


/**
 * The IFluent interface is an adapter interface to wrap reasoner specific 
 * fluent representations.
 */
public interface IFluent {

    /**
     * Returns the name of the fluent.
     */
    public String getName();

    /**
     * @return a term representing the fluent
     */
    public KIFTerm getTerm();

    /**
     * The hashCode method should return the same unique hashCode in case the
     * fluent string representation is identical.
     */
    public int hashCode();


    /**
     * This method should return true if the fluent string representation is
     * identical.
     */
    public boolean equals(Object obj);
}
