package org.eclipse.palamedes.gdl.core.model;

import java.util.Enumeration;

/**
 * Marker Interface
 */
public interface IStatistic {

    // legal move information
    public final static String S_MOVE_COUNT = "Legal Move Count";
    public final static String S_MOVE_CALL  = "Legal Move Calls";
    public final static String S_MOVE_TIME  = "Legal Move Time (ms)";

    // next state information
    public final static String S_STATE_CALL = "Next State Calls";
    public final static String S_STATE_TIME = "Next State Time (ms)";

    // next node information
    public final static String S_NODE_CALL  = "Next Node Calls";

    // just for convenience
    public final static String[] defaultOrder = new String[] {
        S_MOVE_COUNT, S_MOVE_CALL,  S_MOVE_TIME,
        S_NODE_CALL,  S_STATE_CALL, S_STATE_TIME };

    public String         getProperty(String name);
    public Enumeration<?> getPropertyNames();

}
