package org.eclipse.palamedes.gdl.core.model.utils;

import java.util.AbstractList;

import org.eclipse.palamedes.gdl.core.model.IMove;


public final class JoinedList extends AbstractList<IMove[]> {

    private final IMove[][] moveTable;
    private final int[]     columnCount;
    private final int       size;

    public JoinedList(IMove[][] moveTable) {
        this.moveTable = moveTable.clone();

        columnCount = new int[moveTable.length];

        int tmp = 1;
        for (int i = 0, j = moveTable.length; i < j; i++) {
            columnCount[i] = moveTable[i].length;
            tmp           *= columnCount[i];
        }
        size = tmp;
    }

    @Override
    public final IMove[] get(int index) {
        IMove[] moves = new IMove[moveTable.length];
        for (int i = 0; i < moveTable.length; i++) {
            int colCount = columnCount[i];
            moves[i]     = moveTable[i][index % colCount];
            index        = index / colCount;
        }
        return moves;
    }

    @Override
    public final int size() {
        return size;
    }

}
