package org.eclipse.palamedes.gdl.core.resolver.javaprover;

import org.eclipse.palamedes.gdl.core.model.utils.Game;
import org.eclipse.palamedes.gdl.core.model.utils.GameNodeTree;

import cs227b.teamIago.resolver.ExpList;

public class GameJP extends Game {

	public GameJP() {		
	}
	
    public void init(String gdl) {
        super.init( new ReasonerAdapter(gdl), new GameNodeTree() );
        sourceGDL = gdl;

        ReasonerAdapter reasonerAdapter = ((ReasonerAdapter) reasoner);

        // get role names
        ExpList roles = reasonerAdapter.simulator.GetRoles();
        roleNames = new String[roles.size()];
        int i = 0;
        for (Object role : roles.toArrayList())
            roleNames[i++] = role.toString().toLowerCase();

        // set init node
        reasonerAdapter.simulator.SimulateStart();
        StateAdapter state = 
        			new StateAdapter(reasonerAdapter.simulator.GetGameState());
        if ( reasonerAdapter.simulator.IsTerminal() ) {
        	state.setTerminal();
        }
        ((GameNodeTree) tree).setRoot(state);
    }

}
