package org.eclipse.palamedes.gdl.core.resolver.javaprover;

import org.eclipse.palamedes.gdl.core.model.IFluent;
import org.eclipse.palamedes.gdl.core.model.utils.AbstractState;

import cs227b.teamIago.resolver.ExpList;
import cs227b.teamIago.resolver.Expression;
import cs227b.teamIago.util.GameState;


public class StateAdapter extends AbstractState<GameState> {

    public StateAdapter(GameState objState) {
        super(objState);
    }

    @Override
    public void initFluentList() {
        for (Object fluentList : nativeState.getMap().values())
            for (Object exp : ((ExpList) fluentList).toArrayList() )
                fluents.add( new FluentAdapter( (Expression) exp) );
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("(");
        for (IFluent f : getFluents())
            sb.append( f.getTerm().getInfixNotation() ).append(' ');

        return sb.deleteCharAt(sb.length() - 1).append(')').toString();
    }
}
