/*
    Copyright (C) 2008 Stephan Schiffel <stephan.schiffel@gmx.de>

    This file is part of Palamedes-IDE.

    Palamedes-IDE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Palamedes-IDE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Palamedes-IDE.  If not, see <http://www.gnu.org/licenses/>.
*/

package org.eclipse.palamedes.gdl.core.resolver.jocular;

import org.eclipse.palamedes.gdl.core.model.utils.TermWrapper;
import org.eclipse.palamedes.kif.core.ast.AST;
import org.eclipse.palamedes.kif.core.ast.KIFSeq;
import org.eclipse.palamedes.kif.core.ast.KIFTerm;

import stanfordlogic.gdl.SymbolTable;
import stanfordlogic.prover.GroundFact;

public class GroundFactTermAdapter extends TermWrapper<GroundFact> {
	private SymbolTable symbolTable;
	
	public GroundFactTermAdapter(SymbolTable symbolTable, GroundFact expr){
		super(expr);
		this.symbolTable=symbolTable;
	}

	@Override
	public KIFTerm getKIFTerm() {
		KIFSeq<KIFTerm> args=new KIFSeq<KIFTerm>();
		for(int i=0;i<nativeTerm.getArity();i++){
			args.add(TermAdapter.getKIFTerm(symbolTable, nativeTerm.getTerm(i)));
		}
		return new AST().newFunTerm(symbolTable.get(nativeTerm.getRelationName()), args);
	}
}
