package org.eclipse.palamedes.gdl.core.simulation;

public class TimerFlag {

    private boolean abort = false;

    /**
     * Interrupts the processing of the theory. This is done in the MatchTimer
     * class to interrupt processing if we run out of time.
     */
    public void interrupt() {
        abort = true;
    }

    /**
     * Returns whether the theory object was interrupted while doing stuff.
     *
     * @return True if interrupted; otherwise false.
     */
    public boolean interrupted() {
        return abort;
    }

    /**
     * This method resets the interruption flag back to false value.
     *
     */
    public void reset() {
        abort = false;
    }
}
